package com.io.yutian.elementoriginlib.item.stat;

import com.io.yutian.elementoriginlib.item.stat.list.ItemStatId;
import org.jetbrains.annotations.Nullable;

import java.util.HashMap;
import java.util.Map;

public class ItemStats {

    private static Map<Class<? extends ItemStat>, ItemStat<?>> itemStats = new HashMap<>();

    static {
        register(ItemStatId.class, new ItemStatId());
    }

    public static <I extends ItemStat> I register(Class<I> clazz, I itemStat) {
        if (itemStats.containsKey(itemStat.getId())) {
            return itemStat;
        }
        itemStats.put(clazz, itemStat);
        return itemStat;
    }

    public static void unregister(ItemStat itemStat) {
        itemStats.remove(itemStat.getId());
    }

    @Nullable
    public static ItemStat getItemStat(Class<? extends ItemStat> clazz) {
        return itemStats.get(clazz);
    }

    @Nullable
    public static ItemStat getItemStat(String id) {
        for (ItemStat itemStat : itemStats.values()) {
            if (itemStat.getId().equalsIgnoreCase(id)) {
                return itemStat;
            }
        }
        return null;
    }

}
